<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>polylib: pp.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.1 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="main.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>File&nbsp;Members</span></a></li>
    </ul>
  </div>
<h1>pp.c</h1><a href="pp_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of PolyLib.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    PolyLib is free software: you can redistribute it and/or modify</span>
<a name="l00005"></a>00005 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00006"></a>00006 <span class="comment">    the Free Software Foundation, either version 3 of the License, or</span>
<a name="l00007"></a>00007 <span class="comment">    (at your option) any later version.</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    PolyLib is distributed in the hope that it will be useful,</span>
<a name="l00010"></a>00010 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00011"></a>00011 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00012"></a>00012 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00015"></a>00015 <span class="comment">    along with PolyLib.  If not, see &lt;http://www.gnu.org/licenses/&gt;.</span>
<a name="l00016"></a>00016 <span class="comment">*/</span>
<a name="l00017"></a>00017 
<a name="l00018"></a>00018 <span class="preprocessor">#include &lt;stdio.h&gt;</span>
<a name="l00019"></a>00019 <span class="preprocessor">#include &lt;stdlib.h&gt;</span>
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#include &lt;<a class="code" href="polylib_8h.html">polylib/polylib.h</a>&gt;</span>
<a name="l00022"></a>00022 
<a name="l00023"></a><a class="code" href="pp_8c.html#a59799636dce6e7dfa2ce20c48147fa6b">00023</a> <span class="preprocessor">#define WS 0</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a><a class="code" href="pp_8c.html#ae66f6b31b5ad750f1fe042a706a4e3d4">00025</a> <span class="keywordtype">int</span> <a class="code" href="c2p_8c.html#ae66f6b31b5ad750f1fe042a706a4e3d4">main</a>() {
<a name="l00026"></a>00026         
<a name="l00027"></a>00027   <a class="code" href="structmatrix.html">Matrix</a> *a, *b;
<a name="l00028"></a>00028   <a class="code" href="structpolyhedron.html">Polyhedron</a> *A, *B;
<a name="l00029"></a>00029   <a class="code" href="struct__Param__Polyhedron.html">Param_Polyhedron</a> *PA;
<a name="l00030"></a>00030   <a class="code" href="struct__Param__Domain.html">Param_Domain</a> *P;
<a name="l00031"></a>00031   <a class="code" href="struct__Param__Vertex.html">Param_Vertices</a> *V;
<a name="l00032"></a>00032   <span class="keywordtype">int</span> <a class="code" href="polyparam_8c.html#a135433bf69beff8673f093340cbe29be">nbPV</a>, i, j;
<a name="l00033"></a>00033   <span class="keyword">const</span> <span class="keywordtype">char</span> **param_name;
<a name="l00034"></a>00034   
<a name="l00035"></a>00035   a = <a class="code" href="matrix_8c.html#a3a087ae9a03d5baf0b81831177931143">Matrix_Read</a>();
<a name="l00036"></a>00036   <span class="keywordflow">if</span>(!a || a-&gt;<a class="code" href="structmatrix.html#a68858fd3b57684ef38bdfce13c65d182">NbColumns</a> == 0) {
<a name="l00037"></a>00037     fprintf(stderr,<span class="stringliteral">&quot;Input error: empty matrix\n&quot;</span>);
<a name="l00038"></a>00038     exit(0);
<a name="l00039"></a>00039   }
<a name="l00040"></a>00040   A = <a class="code" href="polyhedron_8c.html#aefb77665a187d751bdd44f106b12465e" title="Given a matrix of constraints (&amp;#39;Constraints&amp;#39;), construct and return a polyhedron...">Constraints2Polyhedron</a>(a, <a class="code" href="ext__ehrhart_8c.html#a59799636dce6e7dfa2ce20c48147fa6b">WS</a>);
<a name="l00041"></a>00041   <a class="code" href="matrix_8c.html#afcb312b7c12a6997cd66964ecc34e1a6">Matrix_Free</a>(a);
<a name="l00042"></a>00042   b = <a class="code" href="matrix_8c.html#a3a087ae9a03d5baf0b81831177931143">Matrix_Read</a>();
<a name="l00043"></a>00043   
<a name="l00044"></a>00044   <span class="keywordflow">if</span>(!b || b-&gt;<a class="code" href="structmatrix.html#a68858fd3b57684ef38bdfce13c65d182">NbColumns</a> == 0) {
<a name="l00045"></a>00045     fprintf(stderr, <span class="stringliteral">&quot;Input error: empty matrix\n&quot;</span>);
<a name="l00046"></a>00046     exit(0);
<a name="l00047"></a>00047   }
<a name="l00048"></a>00048   B = <a class="code" href="polyhedron_8c.html#aefb77665a187d751bdd44f106b12465e" title="Given a matrix of constraints (&amp;#39;Constraints&amp;#39;), construct and return a polyhedron...">Constraints2Polyhedron</a>(b, <a class="code" href="ext__ehrhart_8c.html#a59799636dce6e7dfa2ce20c48147fa6b">WS</a>);
<a name="l00049"></a>00049   <a class="code" href="matrix_8c.html#afcb312b7c12a6997cd66964ecc34e1a6">Matrix_Free</a>(b);
<a name="l00050"></a>00050   
<a name="l00051"></a>00051   <span class="comment">/* Read the name of the parameters */</span>
<a name="l00052"></a>00052   param_name = <a class="code" href="param_8c.html#ac5f556f34173ebc8815247ee7f4e2a0b">Read_ParamNames</a>(stdin, B-&gt;<a class="code" href="structpolyhedron.html#a2a02cea8b7ba3dde415041b8b2373bc8">Dimension</a>);
<a name="l00053"></a>00053   PA = <a class="code" href="polyparam_8c.html#a57cedd532b6fbd7a8d7549758eabaf94">Polyhedron2Param_Domain</a>(A,B,<a class="code" href="ext__ehrhart_8c.html#a59799636dce6e7dfa2ce20c48147fa6b">WS</a>);
<a name="l00054"></a>00054   <span class="keywordflow">if</span>(!PA || PA-&gt;<a class="code" href="struct__Param__Polyhedron.html#a23eb52a684bb212c4cf1fbcbd9db066c">D</a>==NULL) {
<a name="l00055"></a>00055     printf(<span class="stringliteral">&quot;---------------------------------------\n&quot;</span>);
<a name="l00056"></a>00056     printf(<span class="stringliteral">&quot;Empty polyhedron\n&quot;</span>);
<a name="l00057"></a>00057     <span class="keywordflow">return</span> 0;
<a name="l00058"></a>00058   }
<a name="l00059"></a>00059   nbPV = PA-&gt;<a class="code" href="struct__Param__Polyhedron.html#abaa0a017c7bef81b5ed9f6d2fd3f6f58">nbV</a>;
<a name="l00060"></a>00060   <a class="code" href="polyhedron_8c.html#ae6d0a7daf8e801a777fc8e93d8cfe43a">Domain_Free</a>(A);
<a name="l00061"></a>00061   <a class="code" href="polyhedron_8c.html#ae6d0a7daf8e801a777fc8e93d8cfe43a">Domain_Free</a>(B);
<a name="l00062"></a>00062 
<a name="l00063"></a>00063   <span class="keywordflow">if</span> (PA-&gt;<a class="code" href="struct__Param__Polyhedron.html#a3daced8ddb352cfa5ed1eeb949f102c5">Rays</a>-&gt;<a class="code" href="structmatrix.html#a16ad614d15c6e81c0041e877b623c72d">NbRows</a> &gt; 0) {
<a name="l00064"></a>00064     printf( <span class="stringliteral">&quot;---------------------------------------\n&quot;</span> );
<a name="l00065"></a>00065     printf( <span class="stringliteral">&quot;Overall rays :\n&quot;</span>);
<a name="l00066"></a>00066     <span class="keywordflow">for</span> (i = 0; i &lt; PA-&gt;<a class="code" href="struct__Param__Polyhedron.html#a3daced8ddb352cfa5ed1eeb949f102c5">Rays</a>-&gt;<a class="code" href="structmatrix.html#a16ad614d15c6e81c0041e877b623c72d">NbRows</a>; i++) {
<a name="l00067"></a>00067       <span class="keywordflow">if</span> (<a class="code" href="source_2arith_2arithmetique_8h.html#a827532f2140ae2aa96e46baebae09723">value_zero_p</a>(PA-&gt;<a class="code" href="struct__Param__Polyhedron.html#a3daced8ddb352cfa5ed1eeb949f102c5">Rays</a>-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[i][0]))
<a name="l00068"></a>00068         printf(<span class="stringliteral">&quot;Line:   [&quot;</span>);
<a name="l00069"></a>00069       <span class="keywordflow">else</span>
<a name="l00070"></a>00070         printf(<span class="stringliteral">&quot;Ray:    [&quot;</span>);
<a name="l00071"></a>00071       <span class="keywordflow">for</span> (j = 1; j &lt; PA-&gt;<a class="code" href="struct__Param__Polyhedron.html#a3daced8ddb352cfa5ed1eeb949f102c5">Rays</a>-&gt;<a class="code" href="structmatrix.html#a68858fd3b57684ef38bdfce13c65d182">NbColumns</a>-1; j++) {
<a name="l00072"></a>00072         <a class="code" href="source_2arith_2arithmetique_8h.html#ad34605b56b571830b928b50a74d618b7">value_print</a>(stdout,<a class="code" href="types_8h.html#ae6f16bcd4a42ba51cbb003e3d1e1cde6">P_VALUE_FMT</a>,PA-&gt;<a class="code" href="struct__Param__Polyhedron.html#a3daced8ddb352cfa5ed1eeb949f102c5">Rays</a>-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[i][j]);
<a name="l00073"></a>00073       }
<a name="l00074"></a>00074       printf(<span class="stringliteral">&quot; ]\n&quot;</span>);
<a name="l00075"></a>00075     }
<a name="l00076"></a>00076   }
<a name="l00077"></a>00077 
<a name="l00078"></a>00078   <span class="comment">/*****************************/</span>
<a name="l00079"></a>00079   <span class="comment">/* Scan the validity domains */</span>
<a name="l00080"></a>00080   <span class="keywordflow">for</span>(P=PA-&gt;<a class="code" href="struct__Param__Polyhedron.html#a23eb52a684bb212c4cf1fbcbd9db066c">D</a>;P;P=P-&gt;<a class="code" href="struct__Param__Domain.html#a5e0de697b290be8c04aeb01af780c557">next</a>) {
<a name="l00081"></a>00081     
<a name="l00082"></a>00082     <span class="comment">/* prints current val. dom. */</span>
<a name="l00083"></a>00083     printf( <span class="stringliteral">&quot;---------------------------------------\n&quot;</span> );
<a name="l00084"></a>00084     printf( <span class="stringliteral">&quot;Domain :\n&quot;</span>);
<a name="l00085"></a>00085     <a class="code" href="polyparam_8c.html#afa315bc856959f9a781359f69b74d7a4">Print_Domain</a>( stdout, P-&gt;<a class="code" href="struct__Param__Domain.html#aac7b708b50ebee4352fddebed2eaba7c">Domain</a>, param_name );
<a name="l00086"></a>00086     
<a name="l00087"></a>00087     <span class="comment">/* scan the vertices */</span>
<a name="l00088"></a>00088     printf( <span class="stringliteral">&quot;Vertices :\n&quot;</span>);
<a name="l00089"></a>00089     <a class="code" href="types_8h.html#aea9236e3c02c25e1cb628684409630fc">FORALL_PVertex_in_ParamPolyhedron</a>(V,P,PA) {
<a name="l00090"></a>00090         
<a name="l00091"></a>00091       <span class="comment">/* prints each vertex */</span>
<a name="l00092"></a>00092       <a class="code" href="polyparam_8c.html#aed63fd8f223a4776c442b144edb03fae">Print_Vertex</a>( stdout, V-&gt;<a class="code" href="struct__Param__Vertex.html#ad61ebc6810df483f7b0e25fea5c6cdf1">Vertex</a>, param_name );
<a name="l00093"></a>00093       printf( <span class="stringliteral">&quot;\n&quot;</span> );
<a name="l00094"></a>00094     }
<a name="l00095"></a>00095     <a class="code" href="types_8h.html#a670b1ea03d880e2595bddca5745df8ec">END_FORALL_PVertex_in_ParamPolyhedron</a>;
<a name="l00096"></a>00096   }
<a name="l00097"></a>00097   <span class="comment">/*****************************/</span>
<a name="l00098"></a>00098   
<a name="l00099"></a>00099   <a class="code" href="polyparam_8c.html#a499deb4842822ae8ae58ed1fdf079c88">Param_Polyhedron_Free</a>( PA );
<a name="l00100"></a>00100   free(param_name);
<a name="l00101"></a>00101   
<a name="l00102"></a>00102   <span class="keywordflow">return</span> 0;
<a name="l00103"></a>00103 } <span class="comment">/* main */</span> 
<a name="l00104"></a>00104 
</pre></div></div>
<hr size="1"/><address style="text-align: right;"><small>Generated on Wed Nov 25 17:45:26 2009 for polylib by&nbsp;
<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.6.1 </small></address>
</body>
</html>
